module load fsl
cd DTI-ENIGMA-FPCA
export Kers=2
#Smooth the Mask
fslmaths Mask.nii.gz -s ${Kers} -mas Mask.nii.gz smoothed_Mask.nii.gz
fslmaths JHU-WhiteMatter-labels-1mm.nii.gz -mul Mask.nii.gz JHU.nii.gz
###################################################################
#Smooth training data
###################################################################
export In=ExampleTrainData
export Out=out/${In}
mkdir -p ${Out}
Sub1=(`ls ${In}`)
for file in ${Sub1[@]}; do
	echo ${file}
	fslmaths ${In}/${file} -s ${Kers} -mas Mask.nii.gz ${Out}/${file}
	fslmaths ${Out}/${file} -div smoothed_Mask.nii.gz ${Out}/${file}
	#masked smoothing: compensate for the initial smoothing using zero values
done
###################################################################
#Smooth test data
###################################################################
export In=ExampleTestData
export Out=out/${In}
mkdir -p ${Out}
export Kers=2
Sub1=(`ls ${In}`)
for file in ${Sub1[@]}; do
	echo ${file}
	fslmaths ${In}/${file} -s ${Kers} -mas Mask.nii.gz ${Out}/${file}
	fslmaths ${Out}/${file} -div smoothed_Mask.nii.gz ${Out}/${file}
done
###################################################################
#Extract the intensity as .txt
###################################################################
module load python/2.7.12
python Extract.py out/ExampleTrainData out/Train FA
python Extract.py out/ExampleTestData out/Test FA
###################################################################
#Generate the FPCA basis from training dataset
###################################################################
module load r/3.6.0
Rscript PC.r out/Train_FA FA 20
###################################################################
#Project the test data to the FPCA basis
###################################################################
Rscript Project.r out/Train_FA out/Test_FA FA 20


