#Rscript PC.r out/Train_FA FA 20
args <- commandArgs() 
print(args[-(1:5)])
data0=args[6]
Patt=args[7] #DTI parameter
S=as.numeric(args[8]) #No of PCs saved
###############################################################################################
#PART 1: Save data in .rds
###############################################################################################
ID=read.table(paste0(data0,'/','id.txt'))[[1]]
sub0=list.dirs(data0,recursive=F)
l=length(sub0)
n=length(ID)
for(j in 1:l)
{
	NAME0=dir(sub0[j])
	IDD=unlist(lapply(strsplit(NAME0,paste0('_',Patt)),'[',1))
	temp=read.table(paste0(sub0[j],'/',NAME0[1]))[[1]]
	p=length(temp)
	M=matrix(NA,n,p)
	for(i in 1:n)
	{
		if(i%%1000==0)print(c(l-j,n-i))
		M[i,]=read.table(paste0(sub0[j],'/',NAME0[i]))[[1]]
	}
	rownames(M)=ID
	saveRDS(M,file=paste0(sub0[j],'.rds'))
}
###############################################################################################
#PART 2: PCA decomposition
###############################################################################################
#To determine PC direction.
sign0<-function(vec)
{
	#thr=quantile(abs(vec),0.99) 
	thr=max(abs(vec))
	ss=sign(vec)[abs(vec)>=thr]
	return(sum(ss==1)/length(ss)+1e-6)
}
sub0=list.dirs(data0,recursive=F)
sub0=unlist(lapply(strsplit(sub0,'/'),'[',3))
l=length(sub0)
for(i in 1:l)
{
	print(l-i)
	M=readRDS(paste0(data0,'/',sub0[i],'.rds'))
	mu0=apply(M,2,mean)
	L=dim(M)
	M=M-rep(1,L[1])%*%t(mu0)
	Cov0=t(M)%*%M/L[1]
	temp=eigen(Cov0)
	eig0=temp$values
	eigv=temp$vectors
	pdf(paste0(data0,'/PC_',sub0[i],'.pdf'))
	plot(cumsum(eig0)/sum(eig0),xlab='Number of PCs',ylab='Contribution of PCs')
	abline(h=0.8,col='blue')
	dev.off()
	write.table((cumsum(eig0)/sum(eig0))[1:100],file=paste0(data0,'/PC_',sub0[i],'.txt'),row.names=F,col.names=F,quote=F)
	sign1=apply(eigv[,1:S],2,sign0)
	eigv[,1:S]=eigv[,1:S]*(rep(1,L[2])%*%t(sign(sign1-0.5)))
	M1=M%*%eigv[,1:S]
	rownames(M1)=rownames(M)
	write.table(M1,paste0(data0,'/PCs_',sub0[i],'_',S,'.txt'))
	write.table(eigv[,1:S],paste0(data0,'/Eigv_',sub0[i],'_',S,'.txt'))
}
