#Rscript Project.r out/Train_FA out/Test_FA FA 20
args <- commandArgs() 
print(args[-(1:5)])
data0=args[6]
data1=args[7]
Patt=args[8] #DTI parameter
S=as.numeric(args[9]) #No of PCs saved
###############################################################################################
#PART 1: Save data in .rds
###############################################################################################
ID=read.table(paste0(data1,'/','id.txt'))[[1]]
sub0=list.dirs(data1,recursive=F)
l=length(sub0)
n=length(ID)
for(j in 1:l)
{
	NAME0=dir(sub0[j])
	IDD=unlist(lapply(strsplit(NAME0,paste0('_',Patt)),'[',1))
	temp=read.table(paste0(sub0[j],'/',NAME0[1]))[[1]]
	p=length(temp)
	M=matrix(NA,n,p)
	for(i in 1:n)
	{
		if(i%%1000==0)print(c(l-j,n-i))
		M[i,]=read.table(paste0(sub0[j],'/',NAME0[i]))[[1]]
	}
	rownames(M)=ID
	saveRDS(M,file=paste0(sub0[j],'.rds'))
}
###############################################################################################
#PART 2: projection
###############################################################################################
sub0=list.dirs(data1,recursive=F)
sub0=unlist(lapply(strsplit(sub0,'/'),'[',3))
l=length(sub0) 
for(i in 1:l)
{ 
	print(l-i)
	M=readRDS(paste0(data1,'/',sub0[i],'.rds'))
	mu0=apply(M,2,mean)
	L=dim(M)
	M=(M-rep(1,L[1])%*%t(mu0))
	eigv=read.table(paste0(data0,'/Eigv_',sub0[i],'_20.txt'))
	M1=M%*%as.matrix(eigv)
	rownames(M1)=rownames(M)
	write.table(M1,paste0(data1,'/PCs_',sub0[i],'_20.txt'))
}